<?php

function gmap_renderer(&$page_ar)
{
	global $database,$p_circle,$params,$html,$config,$ut;
	$buff = '';
	
	$r = array('page'=>$page_ar['id'],'name'=>'map','no-edit'=>true);
	$edit = flexedit($r);
	$edit = str_replace("\n", '', $edit);
	$edit = str_replace("\r", '', $edit);
	$edit = str_replace("\"", "'", $edit);
	$p_map_center = $p_map_title = $p_map_marker = 0;
	$p_map_zoom = 14;

	if (check_rights('edit')) {
		snippet_dialog();
		snippet_inpage_edit();
	}
	
	if (isset($page_ar['meta']['map_page']['p_map_title'])) { $p_map_title = $page_ar['meta']['map_page']['p_map_title']; }
	if (isset($page_ar['meta']['map_page']['p_map_center'])){
		$p_map_center = $page_ar['meta']['map_page']['p_map_center'];
	} else {
		$p_map_center = '33.59169,130.398508';
	}
	if (isset($page_ar['meta']['map_page']['p_map_marker'])) {
		$p_map_marker = $page_ar['meta']['map_page']['p_map_marker']; 
	} else {
		$p_map_marker = '33.589196,130.399452';
	}
	if (isset($page_ar['meta']['map_page']['p_map_zoom'])) { $p_map_zoom = $page_ar['meta']['map_page']['p_map_zoom']; }
	if (isset($page_ar['meta']['map_page']['p_map_x'])) {
		$p_map_x = $page_ar['meta']['map_page']['p_map_x'];
	} else {
		$p_map_x = '400px';
	}
	if (isset($page_ar['meta']['map_page']['p_map_y'])) {
		$p_map_y = $page_ar['meta']['map_page']['p_map_y'];
	} else {
		$p_map_y = '400px';
	}
	if (isset($page_ar['meta']['map_page']['p_map_api'])) {
		$p_map_api = $page_ar['meta']['map_page']['p_map_api'];
	} else {
		$p_map_api = '//maps.google.com/maps/api/js?sensor=false';
	}

	$html['js'][] = "<script src='$p_map_api'></script>";

$tmp = <<<EOT
	<script>
	google.maps.event.addDomListener(window, 'load'
		, function() {
			var mapdiv = document.getElementById('map_canvas');
			var myOptions = {  zoom: $p_map_zoom
								, center: new google.maps.LatLng({$p_map_center})
								, mapTypeId: google.maps.MapTypeId.ROADMAP
								, scaleControl: true
							};
			var map = new google.maps.Map(mapdiv, myOptions); 
			var marker = new google.maps.Marker({
				position: new google.maps.LatLng({$p_map_marker})
				, map: map
				, title: "{$p_map_title}" 
			});
EOT;
			if ($edit && $edit != '...') {
$tmp .= <<<EOT
				var infowindow = new google.maps.InfoWindow({
						content: "<div style='margin:5px'>{$edit}</div>"	// google map bug?
					});
EOT;
			} else {
$tmp .= <<<EOT
				var infowindow = new google.maps.InfoWindow();
EOT;
			}
$tmp .= <<<EOT
			//google.maps.event.addListener(marker, 'click', function() {infowindow.open(map,marker); });
			infowindow.open(map,marker);
		});
	</script>
EOT;
$html['meta'][] = $tmp;


	if (check_rights('owner')) {
$buff .= <<<EOT
		<div class='edit_pointer'>
EOT;
			$buff .= std_blockmenu_renderer($page_ar);
$buff .= <<<EOT
			<a href='javascript:void(ot.inpage_edit({"page":{$page_ar['id']}, "name":"map", "idx":""}))' class='onethird-button mini'>マーカーの編集</a>
			<a href='javascript:void(map_setting())' >{$ut->icon('setting')}</a>
		</div>
EOT;
	}

$buff .= <<<EOT
	<div id="map_canvas" style="width: {$p_map_x}; height: {$p_map_y}"></div> 
	<a href='//maps.google.co.jp/maps?f=q&amp;source=s_q&amp;hl=ja&amp;geocode=&amp;q={$p_map_marker}&amp;sll={$p_map_marker}'>
		 [ 大きい地図を開く ]
	</a>
EOT;

	if (check_rights('edit')) {
$tmp = <<<EOT
	<div id="map_setting" class='onethird-dialog' >
		<div class='title'>Setting</div>
		<div class='onethird-setting'>
			<table>
				<tr>
					<td>マップタイトル</td>
					<td><input type='text' name='p_map_title' id='p_map_title'  />
				</tr>
				<tr>
					<td>マップサイズ(x,y)</td>
					<td><input type='text' name='p_map_x' id='p_map_x' value='$p_map_x'  /><input type='text' name='p_map_y' id='p_map_y' value='$p_map_y' /> </td>
				</tr>
				<tr>
					<td>マップ中央の座標</td>
					<td><input type='text' name='p_map_center' id='p_map_center' />
						<div>ex. 33.588396,130.400091</div>
					</td>
				</tr>
				<tr>
					<td>マップマーカーの座標</td>
					<td><input type='text' name='p_map_marker' id='p_map_marker'  />
						<div>ex. 33.588396,130.400091</div>
					</td>
				</tr>
				<tr>
					<td>ズーム</td>
					<td><input type='number' name='p_map_zoom' id='p_map_zoom' value='$p_map_zoom' /> </td>
				</tr>
				<tr>
					<td>MAP API</td>
					<td><input type='text' name='p_map_api' id='p_map_api'  value='$p_map_api' />
					</td>
				</tr>
			</table>
		</div>
		<div class='actions' >
			<input type='button' class='onethird-button' value='OK' onclick='save_map_setting(this)' />
			<input type='button' class='onethird-button' value='キャンセル' onclick='ot.close_dialog(this)' />
		</div>
	</div>
<script>
	function map_setting() {
		ot.open_dialog(\$('#map_setting'));
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=map_setting"
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					\$('#p_map_title').val(data['map_page']['p_map_title']);
					\$('#p_map_x').val(data['map_page']['p_map_x']);
					\$('#p_map_y').val(data['map_page']['p_map_y']);
					\$('#p_map_center').val(data['map_page']['p_map_center']);
					\$('#p_map_marker').val(data['map_page']['p_map_marker']);
					\$('#p_map_zoom').val(data['map_page']['p_map_zoom']);
				}
			}
		});
	}
	function save_map_setting(obj) {
		var a = '&p_map_title='+\$('#p_map_title').val();
		a += '&p_map_x='+\$('#p_map_x').val();
		a += '&p_map_y='+\$('#p_map_y').val();
		a += '&p_map_center='+\$('#p_map_center').val();
		a += '&p_map_marker='+\$('#p_map_marker').val();
		a += '&p_map_zoom='+\$('#p_map_zoom').val();
		a += '&p_map_api='+\$('#p_map_api').val();
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=save_map_setting"+a
			, dataType:'json'
			, obj:obj
			, success: function(data){
				if ( data && data['result'] ) {
					ot.close_dialog('#map_setting');
				}
			}
		});
	}
</script>
EOT;
		$html['meta'][] = $tmp;
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'map_setting')  {
		$r = array();
		$r['result'] = false;
		$ar = $database->sql_select_all("select metadata from ".DBX."data_items where id=?", $page_ar['id']);
		if ($ar && $ar[0]['metadata']) {
			$m = unserialize64($ar[0]['metadata']);
			if (isset($m['map_page'])) {
				$r['result'] = true;
				$r['map_page'] = $m['map_page'];
			}
		}
		echo(json_encode($r));
		exit();
	}

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_map_setting')  {
		$r = array();
		$r['result'] = false;
		$ar = $database->sql_select_all("select metadata from ".DBX."data_items where id=?", $page_ar['id']);
		if ($ar && $ar[0]['metadata']) {
			$m = unserialize64($ar[0]['metadata']);
			if (isset($m['map_page'])) {
				unset($m['map_page']);
			}
			if (isset($_POST['p_map_title'])) { $m['map_page']['p_map_title'] = sanitize_str($_POST['p_map_title']); }
			if (isset($_POST['p_map_x'])) { $m['map_page']['p_map_x'] = sanitize_str($_POST['p_map_x']); }
			if (isset($_POST['p_map_y'])) { $m['map_page']['p_map_y'] = sanitize_str($_POST['p_map_y']); }
			if (isset($_POST['p_map_center'])) { $m['map_page']['p_map_center'] = sanitize_str($_POST['p_map_center']); }
			if (isset($_POST['p_map_marker'])) { $m['map_page']['p_map_marker'] = sanitize_str($_POST['p_map_marker']); }
			if (isset($_POST['p_map_zoom'])) { $m['map_page']['p_map_zoom'] = sanitize_str($_POST['p_map_zoom']); }
			if (isset($_POST['p_map_api'])) { $m['map_page']['p_map_api'] = sanitize_str($_POST['p_map_api']); }

			if ($database->sql_update( "update ".DBX."data_items set metadata=? where id=?", serialize64($m), $page_ar['id'])) {
				$r['result'] = true;
			}
		}
		echo(json_encode($r));
		exit();
	}

	return frame_renderer($buff);
}


?>